/*
 *  Copyright (c) 1995 John E. Davis  (davis@amy.tch.harvard.edu)
 *  All Rights Reserved.
 */
#ifndef __JED_INDENT_H_
#define __JED_INDENT_H_

typedef struct Syntax_Table_Type
{
   unsigned char string_char;	       /* character for string delim */
   unsigned char char_char;	       /* char for char delim */
   unsigned char comment_type;
#define FORTRAN_TYPE 1
   /* means if non-digit in first column, it is a comment */
#define MULTICHAR_TYPE 2
   /* More than one character form the comment delimeters */
#define EOL_COMMENT_TYPE 4
   /* Comments start and stop on the same line, e.g., 
    * C++ (yuk), S-Lang, Postscript, Fortran, ...
    */
   unsigned char comment_beg;	       /* beginning of comment */
   unsigned char comment_beg2;	       /* second comment beginning char */
   unsigned char comment_end;	       /* end of comment */
   unsigned char comment_end2;	       /* second comment end char */
   unsigned char quote_char;	       /* used for quoting in strings */
   unsigned char preprocess;	       /* start preprocessor lines */
   unsigned char char_syntax[256];     /* syntax type for characters */
   unsigned char matching_delim[256];  /* matching pairs */
   char name[16];		       /* name of this table */
   struct Syntax_Table_Type *next;     /* pointer to next table */
}
Syntax_Table_Type;

extern Syntax_Table_Type *Default_Syntax_Table;

extern int find_matching_delimiter (int *);
extern int parse_to_point (void);
extern void use_syntax_table (char *);
extern void create_syntax_table (char *);
extern void define_syntax (int *, char *);
extern void init_syntax_tables (void);
extern void blink_match(void);
extern int goto_match(void);

#endif /* __JED_INDENT_H_ */
